
Konzepte der Programmierung                       Universität Konstanz
Programmierkurs 2                Informatik & Informationswissenschaft
Sommer 2016                                Marc Scholl, Stefan Klinger

======================================================================

                            25. April 2016

----------------------------------------------------------------------
Erste Begegnung mit Typfehlern

                
    Wir schneiden hier ein paar Themen an die erst später vertieft
    werden.  Mehr dazu dann in den Kapiteln “Haskell – Vorbemerkungen
    zu Typen” (morgen), “Typklassen und Overloading” und “Typinferenz”
    (jeweils später in der VL).


Typen abfragen
--------------

Am GHCi-Prompt kann man sich mit `:type ‹expr›` den Typ eines
Ausdrucks ‹expr› anzeigen lassen.  Ausprobieren:

    :t 'c'
    :t False

Die Funktion `pot` (power of two) von Aufgabe 5:

> pot :: Integer -> Integer
> pot 0 = 1
> pot n = 2 * pot (n-1)
             
    :t pot

Hier kan man schon Currying beobachten:

    :t pot 4


Übrigens: Manchmal weiß der GHCi nicht, wie er einen Wert ausgeben
soll.  Später werden wir das nochmal genauer anschauen:

    *Main> pot
    <interactive>:32:1:
        No instance for (Show (Integer -> Integer))
          (maybe you haven't applied enough arguments to a function?)
          arising from a use of ‘print’
        In a stmt of an interactive GHCi command: print it
  
Wenn man

    No instance for (Show …)

sieht, bedeutet das sowas wie

    Ich weiss nicht wie ich etwas vom Typ … darstellen soll



Listen & Tupel
--------------

Später werden wir Datenstrukturen wie Tupel und Listen genauer
besprechen:

    :t ('c', False)
    :t ('c', False, pot)

    :t [True, True, False]
    :t ['h', 'e', 'l', 'l', 'o']


Obacht!  Die Schreibweise `[·]` wird unterschiedlich verwendet:

    [23] :: [Integer]

Links steht die Liste die den Wert `23` enthält.

Rechts steht der Typ “Liste von Integer-Werten”, und eben *nicht* die
Liste die den Typ `Integer` enthält.  Wir haben keine Listen auf
Typebene (d.h. Listen mit Typen drin).

    [23, 42, 666]                          -- Werte → ok

    [Integer -> Integer, Bool -> Bool]     -- Typen → nicht ok


Ebenso: Paare

    ('c', True) :: (Char, Bool)

Links: Ein Paar von Werten.

Rechts: Ein Typ der Paare von `Char` und `Bool` darstellt, und eben
        *nicht* das Paar der Typen `Char` und `Bool`.


Typen und Werte leben in Haskell in zwei strikt getrennten Welten, der
“Typ-Ebene”, und der “Werte-Ebene”, später mehr dazu…



Strings
-------

    :t "hello"

was sagt uns das?


Strings sind nichts anderes als Listen über Char!  Ausprobieren:

    ['h', 'e', 'l', 'l', 'o']



Typvariablen
------------

Viele Funktionen funktionieren nicht nur für bestimmte Typen wie
`Char` oder `Integer`, sondern für beliebige Typen.  ⇒ Polymorphie 

    :t fst

Kleine/griechische Buchstaben sind Typvariablen!

Was macht diese Funktion vermutlich?

    fst ('a', 'b')

    fst (True, pot)

    :t fst (True, pot)

Obacht: Listen und Tupel sind zwei paar Stiefel!

    fst "hello"



Typklassen
----------

Was für einen Typ hat die 42?

    :t 42

Viele Funktionen oder Konstanten sind polymorph!  Obiges liefert

    42 :: Num a => a

das ist zu lesen als “für jeden *num*erischen Typ α gilt 42 :: α”

Das Literal 42 kann also jeden numerischen Typ annehmen.


Numerische Typen???

Mit `:i ‹name›` erhält man Informationen über den Namen ‹name›, etwa

    *Main> :i Num
    [...]
    instance Num Integer -- Defined in GHC.Num
    instance Num Int -- Defined in GHC.Num
    instance Num Float -- Defined in GHC.Float
    instance Num Double -- Defined in GHC.Float

In den letzten Zeilen, immer nach dem Schlüsselwort `instance`, werden
alle numerischen Typen aufgezählt (später: Instanzen der Klasse
`Num`).  Insbesondere kann die 42 also sowohl als Integer, als auch
als Double aufgefasst werden.



Nochmal Aufgabe 6
-----------------

 > prime :: Integer -> Bool
 > prime n = [ 1 / "text" | x <- [2..n-1], n `mod` x == 0 ] == []

Hier liegt das Problem:

    1 / "text"

Analyse des Typfehlers in Aufgabe 6: `:t (/)` und `:i Fractional`
liefern

    (/) :: Fractional a => a -> a -> a

    instance Fractional Float -- Defined in ‘GHC.Float’
    instance Fractional Double -- Defined in ‘GHC.Float’

aber `:t "text"` liefert

    "text" :: [Char]

insbesondere ist `[Char]` kein “Fractional” Typ, `/` passt also nicht.
Der GHC drückt das so aus:

    No instance for (Fractional [Char]) arising from a use of ‘/’



Typ-Annotation
--------------

Man kann den Typ eines Ausdrucks explizit angeben:

    *Main> 42 :: Integer

    *Main> :t 42 :: Integer

Der Ausdruck `42 :: Integer` ist also vom Typ `Integer`, und nicht
mehr von irgend einem numerischen Typ.

Obacht: Mit `Integer` können wir weniger anfangen:

    *Main> 42 / 7
    *Main> (42 :: Integer) / 7

Woran liegt das?

    *Main> :t 42 / 7
    42 / 7 :: Fractional a => a

Plötzlich `Fractional` statt `Num`.

    *Main> :i Num
    class Num a where
      (+) :: a -> a -> a
      (-) :: a -> a -> a
      (*) :: a -> a -> a
      negate :: a -> a
      abs :: a -> a
      signum :: a -> a
      fromInteger :: Integer -> a
    [...]

    *Main> :i Fractional 
    class Num a => Fractional a where
      (/) :: a -> a -> a
      recip :: a -> a
      fromRational :: Rational -> a
            -- Defined in ‘GHC.Real’
    instance Fractional Float -- Defined in ‘GHC.Float’
    instance Fractional Double -- Defined in ‘GHC.Float’

Die Division `/` funktioniert mit `Float` aber nicht mit `Integer`!

    *Main> (42 :: Float) / 7





Etwas weniger offensichtlich ist der Typfehler hier:

 > prime :: Integer -> Bool
 > prime n = [ x | x <- [2 .. sqrt n], n `mod` x == 0 ] == []

`sqrt` arbeitet nur auf Fließkommazahlen.


Frage: Wie kann man die Bedingung “bis Wurzel n” im Integer-Bereich
       ausdrücken?

 > prime :: Integer -> Bool
 > prime n = [ x | x <- [2 .. n-1], x*x <= n, n `mod` x == 0 ] == []

Was ist der Nachteil dieser Lösung?

Der Test `x*x <= n` wird für alle Zahlen in `[2 .. n-1]` ausgeführt.
Wir lernen später wie wir das umschiffen können.

 

Explizites Umformen zwischen Integer- und Fließkommazahlen:

 > prime :: Integer -> Bool
 > prime n = [ x | x <- [2 .. floor (sqrt (fromIntegral n))]
 >                , n `mod` x == 0
 >           ] == []


Funktionen zur Umwandlung:

    fromIntegral :: (Integral a, Num b) => a -> b

wandelt jeden ganzzahligen Typ α in jeden numerischen Typ β um, und

    ceiling :: (Integral b, RealFrac a) => a -> b
    floor   :: (Integral b, RealFrac a) => a -> b

wandeln jeden “reellen” Typ α in jeden ganzzahligen Typ β um (durch
Auf- bzw. Abrunden).



Mehr zu Typen und Typklassen in späteren Kapiteln...

  * Die meisten Aufgaben können Sie ohne solche Umwandlungen lösen,
    meist bleiben wir im ganzzahligen Bereich.

  * Viele Programmiersprachen machen das automatisch, z.B. JavaScript:
  
          "foo " + 3 + " bar"
        →
          "foo 3 bar"

    Ist das nicht viel besser?


Watch a movie?

    Gary Bernhardt.  Wat.  (video)
    https://www.destroyallsoftware.com/talks/wat


----------------------------------------------------------------------
Nicht-Strikte Auswertung


Bei Aufgabe 6 wurden alle Varianten ohne Typfehler akzeptiert.  Sogar
das Ergebnis stimmt.  Wieso?

 > prime :: Integer -> Bool

 > prime n = [ x | x <- [2..n-1], n `mod` x == 0 ] == []

 > prime n = [ "text" | x <- [2..n-1], n `mod` x == 0 ] == []


Eigentlicher Inhalt der Liste ist irrelevant, z.B. bei `prime 6` :

    [ "text", "text" ] == []   ⇔   [ 2, 3 ] == []

Damit ist klar wieso 42, x und "text" keinen Einfluss auf das Ergebnis
haben.


Was ist aber mit der Division durch Null?

 > prime n =  [ 1 `div` 0 | x <- [2..n-1], n `mod` x == 0 ] == []

Division durch 0 erzeugt eigentlich einen Fehler:

    *Main> 1 `div` 0
    *** Exception: divide by zero

Die Definition von Gleichheit auf Listen sieht so aus:

    []     == []      = True
    (x:xs) == (y:ys)  = x == y && xs == ys
    _      == _       = False


Die `_` auf der linken Seite matchen jeweils alles, und ersparen es
uns einen Variablennamen für Parameter zu verschwenden, auf die wir
nicht zugreifen.

In unserem Programm tritt der mittlere Fall nie auf, die Elemente der
Liste links vom `==` werden also gar nie benötigt. Der Ausdruck `div 1
0` muß also garnicht ausgewertet werden (→ später in Kapitel “Lazy
Evaluation”).



Betrachte folgende Definition:

> strange :: [Int]
> strange = [ 1 `div` 0 | x <- [2,3,4,5], 6 `mod` x == 0 ]

Ausprobieren:
        
    strange
    
    length strange
    
    strange == []



Fragen:

  * Reduziere  [2..9] == [2]

        [2..9] == [2]

      →   | Pattern-Matching bindet:
          | x=2, xs=[3..9], y=2, ys=[]

        2 == 2 && [3..9] == []
      →
        True && False
      →
        False


  * Reduziere  [2..123456789] == [2]

        [2..123456789] == [2]

      →   | Pattern-Matching bindet:
          | x=2, xs=[3..123456789], y=2, ys=[]

        2 == 2 && [3..123456789] == []
      →
        True && False
      →
        False


  * Wie verhalten sich die Anzahlen der benötigten Reduktionsschritte?

  * Kann man daraus etwas über die Anzahl der benötigten
    Reduktionsschritte für `prime 5` und `prime 123456790` ableiten?


======================================================================
