
Konzepte der Programmierung                       Universität Konstanz
Programmierkurs 2                Informatik & Informationswissenschaft
Sommer 2016                                Marc Scholl, Stefan Klinger

======================================================================

                             7. Juni 2016

----------------------------------------------------------------------

> import Prelude

----------------------------------------------------------------------
zu Aufgabe 3, diag


Unendliche Matrix

> matInf :: [[Integer]]
> matInf  = [ [a..] | a <- [1..] ]

Endliche Matrix

> mat m n = take m . map (take n) $ matInf


Eine andere Umsetzung der Idee die Matrix spaltenweise abzuarbeiten:

    [ [ 1, 2, 3             ]
    , [    2, 3, 4          ]
    , [       3, 4, 5       ]
    , [          4, 5, 6    ]
    , [             5, 6, 7 ]
    ]

Frage: Was steht in der Spalte unter der 1?  Wir brauchen einen Wert
       den wir hier verwenden können.


Idee: “Heben” wir das Problem um eine Listenebene an:

    [ [ [1], [2], [3]                     ]
    , [      [2], [3], [4]                ]
    , [           [3], [4], [5]           ]
    , [                [4], [5], [6]      ]
    , [                     [5], [6], [7] ]
    ]

Jetzt kann man mit `[]` den fehlenden Spalteneintrag darstellen:

    [ [ [1], [2], [3]   [],  [],  [],  [] ]
    , [  [], [2], [3], [4],  [],  [],  [] ]
    , [  [],  [], [3], [4], [5],  [],  [] ]
    , [  [],  [],  [], [4], [5], [6],  [] ]
    , [  [],  [],  [],  [], [5], [6], [7] ]
    ]

Die Spalten lassen sich jetzt einfach mit Konkatenation bilden!

> diag :: [[Integer]] -> [Integer]
> diag = concat
>        .
>        ( foldr1
>          $
>          \xs ys -> zipWith (++) (xs ++ repeat []) ([]:ys)   -- f
>        )
>        .
>        (map . map $ \x -> [x])

                        [ Die Quelle der Lösung ist leider unbekannt ]


Testen:

    mat 5 3

    diag $ mat 5 3


Schauen wir uns das stückweise an:

    \x -> [x]                — verpackt ein Element in eine
                               einelementige Liste

    map $ \x -> [x]          — verpackt alle Elemente einer Liste in
                               einelementige Listen.

                               (map $ \x -> [x]) [1..10]

    map . map $ \x -> [x]    — verpackt alle Elemente einer Liste in
                               einelementige Listen.

                               (map . map $ \x -> [x]) $ mat 5 3



Was ist `foldr1`?

    foldr1 :: (a -> a -> a) -> [a] -> a

Was tut das?

    foldr1 (-) [40,50,20]

    foldr1 (-) []

`foldr1 f` ersetzt also nur die “inneren” `:` durch `f`, die leere
Liste am Ende wird ignoriert:

    foldr1 (#) [ 1,  2,  3,  4 ]
    foldr1 (#) $ 1 : 2 : 3 : 4 : []
    foldr1 (#) $ 1 # 2 # 3 # 4


Wir wenden `foldr1` auf die Matrix an, d.h., die Funktion

    f  =  \xs ys -> zipWith (++) (xs ++ (repeat [])) ([]:ys)

ersetzt den `:` zwischen den Zeilen.

     [ [1], [2], [3], [4], [5], [6] ]
     :
     [ [2], [3], [4], [5], [6], [7] ]
     :
     [ [3], [4], [5], [6], [7], [8] ]
     :
     [ [4], [5], [6], [7], [8], [9] ]
     :
     []

wird zu

     [ [1], [2], [3], [4], [5], [6] ]
     f
   ( [ [2], [3], [4], [5], [6], [7] ]
     f
   ( [ [3], [4], [5], [6], [7], [8] ]
     f
     [ [4], [5], [6], [7], [8], [9] ]
   ))

“Rechtsassoziativ” bedeutet hier mit der untersten Zeile beginnend:

          [ [1], [2], [3], [4], [5], [6] ]
         f
       (  [ [2], [3], [4], [5], [6], [7] ]
         f
          [ [3], [4], [5], [6], [7], [8], [],  [], [], [],...
        ___/    /    /    /    /    /    /
       /       /    /    /    /    /    /
     [] : [ [4], [5], [6], [7], [8], [9] ]

       )

Der unteren Zeile (ys) wird `[]` vorangestellt, das sorgt für die
Einrückung.

Die obere Zeile (xs) wird mit leeren Listen aufgefüllt, als Partner
für die überstehenden Elemente der unteren Zeile.

Die beiden Zeilen werden mit `++` gezippt:


          [ [1], [2], [3], [4], [5], [6] ]
         f
       (  [ [2], [3], [4], [5], [6], [7] ]
         f
          [[3],[4,4],[5,5],[6,6],[7,7],[8,8],[9]]
       )

Beim nachsten Aufruf der Funktion `f` ist die unterste Zeile schon
Teil des Ergebnisses:

          [ [1], [2], [3], [4], [5], [6] ]
         f
          [ [2], [3], [4], [5], [6], [7], [],  [], [], [],...
        ___/    /    /    /    /    /     /    /
       /       /    /    /    /    /     /    /
     [] : [[3],[4,4],[5,5],[6,6],[7,7],[8,8],[9]]


          [ [1], [2], [3], [4], [5], [6],    [],     [],   [],  [],...
        ___/    /    /    /     /     |       |       |     |
       /       /    /    /     /      |       |       |     |
     [] : [[2],[3,3],[4,4,4],[5,5,5],[6,6,6],[7,7,7],[8,8],[9]]



“Verschieben & Zippen” leifert auch noch eine weitere Lösung für
`allEqual`:

> allEqual' :: [Integer] -> Bool
> allEqual' xs = and . zipWith (==) xs $ tail xs


----------------------------------------------------------------------
zu Aufgabe 2, splitWords


> splitWords :: String -> [String]

> splitWords [] = []
> splitWords (x:xs) | space x = splitWords xs
>                   | otherwise = word [x] xs
>     where
>     word cs (x:xs) | space x = reverse cs : splitWords xs
>                    | otherwise = word (x:cs) xs
>     word cs [] = reverse cs : []
>
>     space = flip elem " \t\n"


Der Ansatz orientiert sich an einem endlichen Automaten:

                  (start)
                     |
                     V           other
                +---------+    character    +-------+
           /--> | consume | --------------> | build | ---\   other
     space |    | spaces  |                 | word  |    | character
           \--- |         | <-------------- |       | <--/
                +---------+     space       +-------+
                                  |
                            (spit out word)

              
Welcher Teil des Codes entspricht welchem Zustand?


----------------------------------------------------------------------
zu Aufgabe 4


> h, h', h'', h''' :: (a -> Bool) -> [a] -> Int


Gegeben:
                
> h p zs = length (filter p zs)

Tutorium:
     
> h' p = length . filter p


Auch schön:

> h'' = (.) length . filter

       (∘)  ((∘) length)  filter
     = 
       (λf g x. f (g x))  ((∘) length)  filter
    β→
       (λg x. (∘) length (g x))  filter
     =
       (λg x. length ∘ g x)  filter
    β→
       λx. length ∘ filter x


Was ist damit:

> h''' =  ((.) . (.)) length filter


Das ist keine guter Code, aber ein sehr schönes Beispiel wie man
Haskell's Typechecker verwenden kann um das Verhalten einer Funktion
zu ergründen:

Was tut ((.) . (.)) ?


    :t (.) . (.)
    (β → γ) → (α → δ → β) → α → δ → γ      -- Hmmmm


Erste Annäherung: Geben wir den Argumenten Namen.

    ((.) . (.))  konsumiert  f :: β → γ
                             g :: α → δ → β
                             x :: α
                             y :: δ

Also:

    ((.) . (.)) = λf g x y. ???

An den Pfeilen sieht man, dass `f` und `g` Funktionen sein müssen.

Aber wie kann man die Argumente im Rumpf der Funktion sinnvoll
zusammenbauen?

      λf g x y. ?
    =                    -- Rückgabetyp ist γ und nur die Funktion `f`
                            produziert sowas:
      λf g x y. f ?
    =                    -- `f` braucht ein β, nur `g` produziert dies
      λf g x y. f (g ?)
    =                    -- `g` braucht ein α und ein δ, auch dafür
                             gibt es nur die Quellen `x` und `y`.
      λf g x y. f (g x y)
    =                    -- bekannte Umformungen...
      λf g x. f ∘ g x

Also muss gelten:

    (.) . (.)  =  λf g x. f ∘ g x  =  \f g x -> f . g x

Und mit `f = length` , `g = filter` folgt

    h = ((.) . (.)) length filter

Zu dem Thema gibt's auch ein Paper [1], ist aber nicht ganz leichte
Kost (will sagen: Das sollen Sie jetzt nicht unbedingt lesen).


----------------------------------------------------------------------
Ausblick:  Higher kinded types


  * Es ist nicht nötig das vollständig zu verstehen.  Alle Übungen
    lassen sich vorerst ohne “Higher kinded types” verstehen.

  * Wie werden das später (nur oberflächlich) verwenden und dann
    nochmal besprechen.

  * Obacht: “Rabbit Hole” — wir bleiben an der Oberfläche.


Value :: Type; Type :: Kind
---------------------------

Man kann für einen Typ(konstruktor) sagen wieviele Argumente er
braucht. Das ist die Sorte/Art des Typs, engl.:

    “the kind of the type”

(Mit `:k` kann man den GHCi nach der Art des Typs fragen.)


  * Typen die Werte enthalten können, bekommen Kind `*`.
  
    `Int` enthält z.B. den Wert `42`

        :k Int

    `String -> [String]` enthält z.B. den Wert `words`

        :k String -> [String]

    Dabei muss ein entsprechender Wert nicht unbedingt definiert sein:

        :k Int -> Bool

  * Im Gegensatz enthalten Typkonstruktoren keine Werte!

        :k Maybe
        :k []

    Der Kind `* -> *` bedeutet:

      - Gib mir einen Typ der Werte enthält (linker `*`),
      
      - ich konstruiere einen Typ der Werte enthält (rechter `*`).

  * Das geht auch mit mehreren Parametern:

        :k Either
        :k (,)
        :k (->)

    auch hier ist `->` rechtsassoziativ, also

        Either :: * -> (* -> *)

Typen der Art `* -> ...` heißen “higher kinded Types”.



Offensichtliche Frage:

    Kann man einen Typ der Art `(* -> *) -> *` konstruieren?

Dazu muss man einen Typkonstruktor beschreiben, der einen
Typkonstruktor konsumiert.  Das geht tatsächlich:

> data Bar t = B (t Int)

    :k Bar

In der Typdefinition wird `t` auf einen Typ (`Int`) angewendet, muss
also der Art `* -> *` sein.

Frage: Was stellt `Bar` dar?

    :t B [1..10]
    :t B (Just 42)

Antwort: Beliebige Strukturen über `Int`.  Insbesonder *nicht*:

    :t B (Just 2.3)                   


Aktuelle Versionen des GHCi zeigen den Kind von `t` auch an:

    *Main> :i Bar
    data Bar (t :: * -> *) = B (t Int)      -- Hier



Klassen mit higher-kinded Parametern
------------------------------------

> class First t where
>   first :: t a -> Maybe a

    :t first



Auch hier erkennt man an der Position des `t` vor dem `a`, dass `t`
ein Typkonstruktor sein muss.  

    *Main> :i First
    class First (t :: * -> *) where
      first :: t a -> Maybe a
            -- Defined at pk2-08.lhs:385:3

> instance First [] where

       first :: t a -> Maybe a
     ⇒     t = []
       first :: [] a -> Maybe a
     =
       first :: [a] -> Maybe a

>   first (x:_) = Just x
>   first []    = Nothing

    first [1..10]



> instance First BinTree where
>   first (Node _ x _) = Just x
>   first Empty        = Nothing

    first $ Node (leaf 1) 2 (leaf 3)



Kann man `Either` zur Instanz von `First` machen?

 > instance First Either where
 >   first = undefined           -- das überlegen wir uns später.


Nein, das geht nicht!

    Expecting one more argument to ‘Either’
    The first argument of ‘First’ should have kind ‘* -> *’,
      but ‘Either’ has kind ‘* -> * -> *’
    In the instance declaration for ‘First Either’


Aber: Auch Typkonstruktoren können partiell angewendet werden.

    :k Either
    :k Either Int
    :k Either Int Char

> instance First (Either a) where

      first :: t b -> Maybe b

    =   -- weil jetzt  t = Either a      -- type-level currying !

      first :: Either a b -> Maybe b

>   first (Right x) = Just x
>   first _ = Nothing



Foldable
--------

Jetzt können wir auch den echten Typ von Funktionen wie z.B. `length`
verstehen:

    *Main> :t length
    length :: Foldable t => t a -> Int

Also muss `t` ein Typkonstruktor sein.

    class Foldable (t :: * -> *) where
      foldr :: (a -> b -> b) -> b -> t a -> b
      foldl :: (b -> a -> b) -> b -> t a -> b
      null :: t a -> Bool
      length :: t a -> Int
      elem :: Eq a => a -> t a -> Bool
      maximum :: Ord a => t a -> a
      minimum :: Ord a => t a -> a
      sum :: Num a => t a -> a
      product :: Num a => t a -> a
      [...]

Leider:

  * `Foldable t` hat nichts damit zu tun dass man einen “Fold” über
    einem Typkonstruktor `t` hätte (cf. Folie 290).

  * `Foldable t` bedeutet eher dass man über die Elemente von `t α`
    iterieren kann.

  * Versuchen Sie *nicht* Instanzen von `Foldable` zu erzeugen.  Das
    ist etwas kompliziert...


----------------------------------------------------------------------


[1] Philip Wadler.  “Theorems for free!”.  In “Functional Programming
    Languages and Computer Architecture”, 1989, pp. 347–359, ACM
    Press.  <http://ttic.uchicago.edu/~dreyer/course/papers/wadler.pdf>


======================================================================
Das haben wir weiter oben verwendet...


> data BinTree a
>     = Empty
>     | Node (BinTree a) a (BinTree a)
>     deriving Eq
>
> leaf :: a -> BinTree a
> leaf x = Node Empty x Empty
>
> atree :: BinTree Int
> atree = Node (leaf 1) 2 (leaf 3)

> instance Show a => Show (BinTree a) where
>   showsPrec _ = foldl (.) id . ppt
>     where
>       ppt :: Show a => BinTree a -> [ShowS]
>       ppt Empty = [showString "@\n"]
>       ppt (Node l x r)
>         = shows x . showString "\n"
>           :
>           indent "|--" "|  " (ppt l)
>           ++
>           indent "`--" "   " (ppt r)
>       indent :: String -> String -> [ShowS] -> [ShowS]
>       indent i1 i2 (x:xs)
>         = showString i1 . x : map ((showString i2) .) xs

======================================================================
