
Konzepte der Programmierung                       Universität Konstanz
Programmierkurs 2                Informatik & Informationswissenschaft
Sommer 2016                                Marc Scholl, Stefan Klinger
                                          Vertretung: Leonard Wörteler
======================================================================

                            20. Juni 2016

----------------------------------------------------------------------
Organisatorisches


  * Diese Woche findet am Mittwoch die Lehrevaluation für KdP&PK2
    statt.  Bitte zahlreich erscheinen.

  * Auf `titan07` ist jetzt auch der GHC 8.0.1 installiert:

        /local_tmp/inf2_16s/bin/ghci-8.0.1

    Für uns sollten sich keine relevanten Änderungen ergeben.

  * Das Übungsblatt kommt heute erst spät heraus, es kommt aber
    sicher!


----------------------------------------------------------------------

> import qualified Data.Set as S
> import Data.List ( intersperse )

----------------------------------------------------------------------
Bekannter Code


Datentyp für λ-Ausdrücke...

> data LExpr
>   = Var String         -- Variable
>   | App LExpr LExpr    -- Funktionsapplikation
>   | Lam String LExpr   -- Lambda-Abstraktion  

...instanziiert zu `Show`:

> instance Show LExpr where
>   showsPrec _ (Var v) = showString v
>   showsPrec p (App e1 e2) 
>     = showParen (p == 2)
>       $
>       showsPrec 1 e1 . showChar ' ' . showsPrec 2 e2
>   showsPrec p (Lam v e) 
>     = showParen (p > 0) $ showChar '\\' . showString v . f e
>     where
>       f (Lam v e) = showChar ' ' . showString v . f e
>       f other = showString " -> " . shows other

Der passende `fold` dazu:

> lfold :: (String -> a) -> (a -> a -> a) -> (String -> a -> a)
>       -> LExpr -> a
> lfold var app lam = go
>   where
>     go (Var v)     = var v
>     go (App e1 e2) = app (go e1) (go e2)
>     go (Lam v e)   = lam v $ go e

Zum Testen:

> e1 = (Lam "x" . Lam "y" $ Var "y")
>      `App`
>      ((Lam "z" $ Var "z") `App` Var "foo")
>      `App`
>      Var "bar"

> e2 = (Lam "x" $ (Lam "y" $ Var "y") `App` Var "z")

> e3 = (Lam "f" $ Var "f" `App` Var "z")
>      `App`
>      (Lam "y" $ (Lam "x" $ Var "x") `App` Var "y")

> e4 = (Lam "x" . Lam "y" $ Var "y")
>      `App`
>      ((Lam "z" $ Var "z") `App` Var "foo")
>      `App`
>      ((Lam "a" $ App (Var "f") $ Var "a") `App` Var "bar")


----------------------------------------------------------------------
zu Aufgabe 2, `lfold`


Mit `lfold` lassen sich die *Mengen* der freien Variablen und der
Bindungen bestimmen (im Tutorium hatten wir die Varianten mit Listen):

> free :: LExpr -> S.Set String
> free = lfold S.singleton S.union S.delete

> bindings :: LExpr -> S.Set String
> bindings = lfold (const S.empty) S.union S.insert

> freeAndBound :: LExpr -> (S.Set String, S.Set String)
> freeAndBound = 
>   lfold
  
    Eine Variable erzeugt das Paar ({v}, {}):

>   (\v -> (S.singleton v, S.empty))

    Für Applikation müssen wir einfach komponentenweise die
    Vereinigung bilden:

>   (\(fl,bl) (fr,br) -> (S.union fl fr, S.union fr br))

    Was genau müssen wir für die Abstraktion tun?

>   (\v p@(f,b) -> if S.member v f
>                  then (S.delete v f, S.insert v b)
>                  else p
>   )

> bound  :: LExpr -> S.Set String
> bound = snd . freeAndBound

- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

Teil der Musterlösung (wird in den Tutorien besprochen):

 > q `freeIn` (Var v) = q==v
 > q `freeIn` (App e1 e2) = q `freeIn` e1 || q `freeIn` e2
 > q `freeIn` (Lam v b) = q /= v && q `freeIn` b

 > subst :: LExpr -> String -> LExpr -> LExpr
 > subst m x e     
 >   = case e of
 >       Var v | x==v -> m
 >             | otherwise -> e
 >       App e1 e2 -> subst m x e1 `App` subst m x e2
 >       Lam v b | x == v       -> e
 >               | v `freeIn` m -> subst m x . Lam z $ subst (Var z) v b
 >               | otherwise    -> Lam v $ subst m x b
 >         where
 >           z = head [ z
 >                    | n <- [0..]
 >                    , let z = v ++ show n
 >                    , not $ z `freeIn` m
 >                    , not $ z `freeIn` b
 >                    ]

> subst :: LExpr -> String -> LExpr -> LExpr
> subst m x = go
>   where
>     fm = free m
>     go e@(Var v) | x == v    = m
>                  | otherwise = e
>     go (App e1 e2) = go e1 `App` go e2
>     go e@(Lam v b) | x == v        = e
>                    | S.member v fm = go . Lam z $ subst (Var z) v b
>                    | otherwise     = Lam v $ go b
>       where
>         z = head [ z
>                  | n <- [0..]
>                  , let z = 'x' : show n
>                  , not $ S.member z fm
>                  , not $ S.member z $ free b
>                  ]

    Lam "x" (Var "x" `App` Var "y" `App` Var "x0")
    subst (Var "x") "y"

Heute auf dem Übungsblatt: Bauen Sie die Funktion `lazy`, die ihr
Argument auf WHNF reduziert.  Die Lösung ist sehr ähnlich zu `eager`,
das besprechen wir also nicht.  Finden Sie heraus wie's
funktioniert...

> eager :: LExpr -> LExpr
> eager = flip go []
>     where
>     go (App e1 e2) es     = go e1 (e2 : es)
>     go (Lam x b)   (e:es) = go (subst (eager e) x b) es
>     go other       es     = foldl App other es

    e1
    eager e1


Übrigens: Diese Funktion reduziert nicht *unterhalb* einer
          λ-Abstraktion, d.h., auch `eager` reduziert nur bis zur
          WHNF(?), aber eben immer das Argument vor der β-Reduktion.

          Was ist aber mit dem folgenden Ausdruck?

> loop = (Lam "x" (Var "x" `App` Var "x")) `App` (Lam "x" (Var "x" `App` Var "x"))
> e5 = (Lam "_" $ Var "42") `App` loop

Besserer name `eager-ish`?


Die einzelnen Reduktionsschritte kann man mit `eager'` (s. unten)
anzeigen lassen.  Die folgende Funktion ist *deutlich* komplexer
(müssen Sie nicht nachvollziehen), produziert dafür aber eine Liste
mit Zwischenergebnissen.  Diesen Ansatz sollten Sie für `lazy` nicht
unbedingt verfolgen, ist nicht einfach...

> eagerTrace :: LExpr -> [LExpr]
> eagerTrace e = e : go e [] []
>     where
>     go (App e1 e2) es ls = go e1 (e2:es) ls
>     go (Lam x b) (e:es) ls = go e [] ((x,b,es):ls)
>     go e es ((x,b,es'):ls)
>       = foldl (\e (x,b,es) -> foldl App (Lam x b) $ e:es)
>               (foldl App e' es')
>               ls
>         :
>         go e' es' ls
>       where
>       e' = subst (foldl App e es) x b
>     go e es _ = []

Und diese nächste Funktion erzeugt schließlich eine schöne Ausgabe,
das verstehen wir aber erst nächste Woche!

> eager' :: LExpr -> IO ()
> eager'
>     = (putStrLn . unlines . ("":) . intersperse "->" . map (("  "++) . show))
>       .
>       eagerTrace

                     
Ausprobieren:

    eager' e1

      * Das Argument `((λz. z) foo)` wird vor dem Einsetzen reduziert.

    eager' e2

      * Der ganze Term ist eine nicht-angewandte λ-Abstraktion, wir
        reduzieren also nicht weiter.

    eager' e3

      * Das Argument `(λy. (λx. x) y)` ist eine nicht-angewandte
        λ-Abstraktion, also in WHNF.  Also wird es eingesetzt.

      * Danach steht wieder ein Argument `z` zur Verfügung, und es
        wird weiter reduziert.
           

- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
Mit dem gezeigten λ-Kalkül kann man schon arbeiten

    
Ich brauche noch ein paar Hilfsmittel, damit ich nicht gar so viel
tippen muss:

> undef = Var "UNDEFINED"
  
> cnst = Lam "x" . Lam "y" $ Var "x"

    cnst `App` Var "one" `App` Var "two"
    eager it


> app []     = error "empty application"
> app (x:xs) = foldl App x xs          -- app = foldl1 App

Frage: Was hat `app` für einen Typ?

    app [cnst, Var "one", Var "two"]


        
Datenstruktur: Paare
^^^^^^^^^^^^^^^^^^^^

Das hatten wir in der Vorlesung schon besprochen:

    pair = λa b f. f a b
    
    first = λp. p (λx y. x)
    second = λp. p (λa b. b)
        
> pair = Lam "a" . Lam "b" . Lam "f" $ app [Var "f", Var "a", Var "b"]

> first = Lam "p" $ Var "p" `App` (Lam "x" . Lam "y" $ Var "x")
> second = Lam "p" $ Var "p" `App` (Lam "a" . Lam "b" $ Var "b")

    pair `App` Var "Bonnie" `App` Var "Clyde"
    first `App` it
    eager' it

    second `App` (pair `App` Var "Bonnie" `App` Var "Clyde")
    eager' it


Ebenso gibt es Codierungen für Integer (“Church numerals”), Booleans
(“Church booleans”), und den üblichen Operationen darauf...


Datenstruktur: Listen
^^^^^^^^^^^^^^^^^^^^^
  
Algebraische Datentypen kann man prinzipiell durch den “zugehörigen”
`fold` darstellen.  Bei Listen ist das `foldr`.

  * Wir sind uns noch nicht klar darüber wie wir Konstruktoren
    darstellen.

  * Deswegen repräsentieren wir eine List durch eine Funktion, welche
    alle Listen-Konstruktoren als Argument konsumiert.

Beispiel:    

      1 : 2 : 3 : 4 : 5 : []
      
      λ c n . c 1 (c 2 (c 3 (c 4 (c 5 n))))

      Das entspricht `λc n. foldr c n [1,2,3,4,5]`
    
Wenn wir `:` und `[]` hätten, dann könnten wir mit

      ( λ c n . c 1 (c 2 (c 3 (c 4 (c 5 n)))) ) (:) []
    →
      ( λ n . 1 : 2 : 3 : 4 : 5 : n ) []
    →
      1 : 2 : 3 : 4 : 5 : []

unsere Liste wieder konstruieren.


                   ??? Hätte hätte Fahrradkette ???

  
Die leere Liste sieht erstmal so aus:
    
    nil = λc n. n               -- denn:  nil (:) [] → []


    
Wollen wir ein Element `x` an eine Liste

    xs = λc n.…

anfügen, dann müssen wir dazu natürlich den gleichen cons-Operator `c`
verwenden den auch `xs` verwendet:

    λc n. c x (xs c n)          -- neue Liste der Gestalt `λc n.…`

denn

      (λc n. c x (xs c n)) (:) []
    →
      (:) x (xs (:) [])
    =
      (:) x ((λc n.…) (:) [])

Damit sieht `cons` so aus:

    cons = λx xs. λc n. c x (xs c n)  
    
So, fertig.

> nil = Lam "c" . Lam "n" $ Var "n"

> cons = Lam "x" . Lam "xs" . Lam "c" . Lam "n"
>        $
>        app [Var "c", Var "x", app [Var "xs", Var "c", Var "n"]]

    nil
    cons `App` Var "1" `App` nil
    cons `App` Var "1" `App` (cons `App` Var "2" `App` nil)

> list = foldr App nil . map (App cons)

    list [Var "1", Var "2", Var "3"]

    

Wie kann man denn auf den Kopf einer Liste zugreifen?
         
      hd (λc n. c h (t c n))
    →
      h

Wie müsste `hd` aussehen?

Es reicht aus, `cnst = λx y. x` an die Liste zu übergeben:

    hd = λxs. xs (λx y. x) UNDEFINED
    
> hd = Lam "xs" $ app [ Var "xs"
>                     , Lam "h" . Lam "t" $ Var "h"
>                     , undef
>                     ]

Ausprobieren:

    App hd nil
    eager it 

    App hd $ list [Var "1", Var "2", Var "3"]
    eager it 


Der Test ob eine Liste leer ist, sieht so aus:
         
    λxs. xs (λy ys. False) True
        
> isNil = Lam "xs" $ app [ Var "xs"
>                        , Lam "h" . Lam "t" $ Var "False"
>                        , Var "True"
>                        ]

Ausprobieren:

    isNil `App` list [Var "1", Var "2", Var "3"]
    eager it 

    isNil `App` nil
    eager it 

    

Deutlich trickreicher ist die `tail` Funktion:

    tl = λxs. first ( xs c n )
         where
         n = pair undef nil
         c = λh p. pair t (cons h t)
             where
             t = second p

> tl = Lam "xs" $ first `App` app [Var "xs", c, n]
>     where
>     n = app [pair, undef, nil]
>     c = Lam "h" . Lam "t1" $ app [pair, t2, app [cons, Var "h", t2]]
>     t2 = second `App` Var "t1"

Ausprobieren:      
   
    tl `App` nil
    eager it

    App hd $ App tl $ list [Var "1", Var "2", Var "3"]
    eager it

    App hd $ App tl $ App tl $ list [Var "1", Var "2", Var "3"]
    eager it

    App hd $ App tl $ App tl $ App tl $ list [Var "1", Var "2", Var "3"]
    eager it




Probleme mit `tl`?
^^^^^^^^^^^^^^^^^^

 * Kompliziert,
 * langsam!

Um die Restliste zu bekommen, muss man die gesamte Liste auseinander-
und wieder zusammenbauen. Geht das schneller?

Bis jetzt haben wir Datenstrukturen durch ihren `fold` dargestellt.
Könnte auch die Fallunterscheidung `case` eine sinnvolle Kodierung sein?

Nehmen wir als Beispiel wieder Listen:

  data [a]
    = []
    | (:) a [a]

Eine Liste wird jetzt dargestellt als eine Fallunterscheidung über
den äußersten Datenkonstruktor:

  encoded l = λc n.
    case l of
      []   -> n
      x:xs -> c x xs

Vorher hatten wir:

  church l = λc n. foldr c n l

Oder, anders dargestellt:

  church l = λc n.
    case l of
      []   -> n
      x:xs -> c x (church xs c n)


Wie stellen wir nun mit dieser neuen Kodierung (Scott-Kodierung genannt)
die Listenoperationen `cons`, `nil`, `hd` und `tl` dar?

  nil' = λc n. n

> nil' = Lam "c" . Lam "n" $ Var "n"

  cons' = λx xs. λc n. c x xs

> cons' = Lam "x" . Lam "xs" . Lam "c" . Lam "n" $ app [Var "c", Var "x", Var "xs"]

  hd' l
    = case l of [] -> undefined; x:xs -> x
    = l (λx xs. x) undefined

> hd' = Lam "l" $ app [Var "l", Lam "x" . Lam "xs" $ Var "x", undef]



...und jetzt zum Höhepunkt:

  tl' l
    = case l of [] -> undefined; x:xs -> xs
    = l (\x xs -> xs) undefined

> tl' = Lam "l" $ app [Var "l", Lam "x" . Lam "xs" $ Var "xs", undef]

Es ist kein Rekonstruieren einer Liste nötig! Die Probleme mit
Church-kodierten Listen scheinen gelöst zu sein.

Ausprobieren:      

> list' = foldr App nil' . map (App cons')
   
    tl' `App` nil'
    eager it

    App hd' $ App tl' $ list' [Var "1", Var "2", Var "3"]
    eager it

    App hd' $ App tl' $ App tl' $ list' [Var "1", Var "2", Var "3"]
    eager it

    App hd' $ App tl' $ App tl' $ App tl' $ list' [Var "1", Var "2", Var "3"]
    eager it





Aber:
^^^^^

Was ist der Typ einer Church-Liste mit Elementtyp `a`?

  > churchList :: [a] -> _
  > churchList l = \c n -> foldr c n l

Und der einer Scott-Liste?
  
  > scottList l = [a] -> _
  > scottList l = \c n -> case l of [] -> n; x:xs -> c x (scottList xs)

  
Die Scott-Kodierung kann im Hindley-Milner-Typsystem nicht typisiert
werden, es ergibt sich ein unendlicher Typ! Das ist mit Church-Kodierung
niemals der Fall.
  

======================================================================
