
Konzepte der Programmierung                       Universität Konstanz
Programmierkurs 2                Informatik & Informationswissenschaft
Sommer 2016                                Marc Scholl, Stefan Klinger

======================================================================

                             4. Juli 2016

----------------------------------------------------------------------

> import Data.List ( intersperse )
> import qualified Data.Set as S

----------------------------------------------------------------------
Wir gucken einen Film...


    Simon Peyton Jones. Adventure with Types in Haskell, Lecture 1.
    https://youtu.be/6COvD8oynmI

Teil einer Serie mit 4 Vorlesungen.

  * ab 0:18:00: Wie kann der Compiler Typklassen implementieren?
    https://youtu.be/6COvD8oynmI?t=1080

  * ab 0:34:40: QuickCheck, eine coole Anwendung von Ad-Hoc
    Polymorphie.
    https://youtu.be/6COvD8oynmI?t=2080

  * ab 0:47:00: Vergleich OO-Typklassen und Haskell Typklassen, und
    etwas später ein Vergleich der beiden Polymorphie-ansätze aus der
    OO- und der ML-Gemeinde.

Das ist mal interessant zu sehen, insbesondere die halbe Stunde von
0:18:00 bis 0:47:00.  Nicht relevant für die Prüfung.


----------------------------------------------------------------------
λ-Kalkül & Combinatory Logic


Den λ-Kalkül kennen wir bereits, und wir hatten auch bereits einen
Auswerter dafür gebaut, siehe `pk2-10.lhs`.  Hier nochmal der Code
dazu:

> data LExpr
>     = Var String         -- Variable
>     | App LExpr LExpr    -- Funktionsapplikation
>     | Lam String LExpr   -- Lambda-Abstraktion  
>     deriving Eq

> instance Show LExpr where
>     showsPrec _ (Var v) = showString v
>     showsPrec p (App e1 e2) 
>         = showParen (p == 2)
>           $
>           showsPrec 1 e1 . showChar ' ' . showsPrec 2 e2
>     showsPrec p (Lam v e) 
>         = showParen (p > 0) $ showChar 'λ' . showString v . f e
>         where
>         f (Lam v e) = showChar ' ' . showString v . f e
>         f other = showString ". " . shows other

> lfold :: (String -> a) -> (a -> a -> a) -> (String -> a -> a)
>       -> LExpr -> a
> lfold var app lam = go
>   where
>     go (Var v)     = var v
>     go (App e1 e2) = app (go e1) (go e2)
>     go (Lam v e)   = lam v $ go e

> free :: LExpr -> S.Set String
> free = lfold S.singleton S.union S.delete

> subst :: LExpr -> String -> LExpr -> LExpr
> subst m x = go
>   where
>     fm = free m
>     go e@(Var v) | x == v    = m
>                  | otherwise = e
>     go (App e1 e2) = go e1 `App` go e2
>     go e@(Lam v b) | x == v        = e
>                    | S.member v fm = go . Lam z $ subst (Var z) v b
>                    | otherwise     = Lam v $ go b
>       where
>         z = head [ z
>                  | n <- [0..]
>                  , let z = 'x' : show n
>                  , not $ S.member z fm
>                  , not $ S.member z $ free b
>                  ]


Die Funktion`lazyTrace` implementiert normal-order reduction, und gibt
die Zwischenschritte aus:

> lazyTrace :: LExpr -> [LExpr]
> lazyTrace e = go e []
>   where

      Solange der aktuelle Knoten eine Applikation ist, steige nach
      links ab.

>     go (App e1 e2) es     = go e1 (e2:es)

      Eine λ-Abstraktion mit Argument `e` wird reduziert.  Mit dem
      darüberliegenden Baum `es` rekonstruieren wir den neuen Term.

>     go (Lam x b)   (e:es) = let e' = subst e x b
>                             in foldl App e' es : go e' es

      Alles andere kann nicht reduziert werden.
      
>     go other       es     = [] -- no more steps


Wenn wir nur am Endergebnis interessiert sind:
         
> lazy :: LExpr -> LExpr
> lazy = last . lazyTrace


Und wieder die Funktion die eine schöne Ausgabe erzeugt.

> lazy' :: LExpr -> IO ()
> lazy' e = printSteps $ e : lazyTrace e
  
> printSteps :: Show a => [a] -> IO ()
> printSteps
>     = putStrLn . unlines . ("":) . intersperse "→"
>       .
>       map (("  "++) . show)


- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
Hilfsfunktionen



> app :: [LExpr] -> LExpr
> app = foldl1 App


Vordefinierte λ-Terme

> undef, cnst :: LExpr
> undef = Var "UNDEFINED"
> cnst = Lam "x" . Lam "y" $ Var "x"


Paare

> pair, first, second :: LExpr
> pair = Lam "a" . Lam "b" . Lam "f" $ app [Var "f", Var "a", Var "b"]
> first = Lam "p" $ Var "p" `App` (Lam "x" . Lam "y" $ Var "x")
> second = Lam "p" $ Var "p" `App` (Lam "a" . Lam "b" $ Var "b")

    app [pair, Var "Bonnie", Var "Clyde"]

    first `App` app [pair, Var "Bonnie", Var "Clyde"]

    second `App` app [pair, Var "Bonnie", Var "Clyde"]


Listen

> nil, cons :: LExpr
> nil = Lam "c" . Lam "n" $ Var "n"
> cons = Lam "x" . Lam "xs" . Lam "c" . Lam "n"
>        $ app [Var "c", Var "x", app [Var "xs", Var "c", Var "n"]]


> hd, tl :: LExpr
> hd = Lam "xs" $ app [Var "xs", Lam "h" . Lam "t" $ Var "h", undef]
> tl = Lam "xs" $ first `App` app [Var "xs", c, n]
>     where
>     n = app [pair, undef, nil]
>     c = Lam "h" . Lam "t1" $ app [pair, t2, app [cons, Var "h", t2]]
>     t2 = second `App` Var "t1"


- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
zu Aufgabe 2


Der Y-Combinator

    λx. (λy. x (y y)) (λy. x (y y))

> yc :: LExpr
> yc = Lam "x" $ a `App` a
>     where
>     a = Lam "y" $ Var "x" `App` (Var "y" `App` Var "y")


Gesucht war `F` mit

    Y F m  ≡  m : Y F (m+1)

Das gilt für

    F = λg m. m : g (m + 1)


Wir verwenden `cons` von oben, und eine Variable `succ` um die
Addition von 1 darzustellen:

    F = λg m. cons k (g (succ m))

> f :: LExpr
> f = Lam "g" . Lam "m"
>     $
>     app [cons, Var "m", Var "g" `App` (Var "succ" `App` Var "m")]


Der gesuchte Generator `[3..]` ist dann

> gen :: LExpr
> gen = yc `App` f `App` Var "3"

Testen:

    lazy' $ gen
    lazy' $ hd `App` gen
    lazy' $ hd `App` (tl `App` gen)
    lazy' $ hd `App` (tl `App` (tl `App` gen))

  
----------------------------------------------------------------------
Combinatory Logic


Im Folgenden wird ein anderer Kalkül vorgestellt, der genauso mächtig
(ausdrucksstark) ist, wie der λ-Kalkül.


K-Kombinator (constant function constructor)

    K = λx y. x

> kc :: LExpr
> kc = Lam "x" . Lam "y" $ Var "x"

Für alle `x` ist `K x` die konstante Funktion, die `x` liefert:

    lazy $ kc `App` Var "fourtytwo"

    

S-Kombinator (substituted application)

    S = λf g x. f x (g x)

> sc :: LExpr
> sc = Lam "f" . Lam "g" . Lam "x"
>      $
>      (Var "f" `App` Var "x") `App` (Var "g" `App` Var "x")

Was tut das?

    S f g x → (f x) (g x)

    lazy $ app [sc, Var "f", Var "g", Var "x"]

Man könnte sagen: `S f g x` ist die “Anwendung” von `f` auf `g`,
*nachdem* beide mit dem Parameter `x` versorgt wurden.

Tatsächlich gilt

    λx. f g  ≡  S (λx. f) (λx. g)                                 -- (*)

Beweis:

       (\x. f g) e                       S (λx. f) (λx. g) e
    β→                                 →     —Definition von S
       (f g)[x←e]                        ((λx. f) e) ((λx. g) e)
    =                                2β→
       f[x←e] g[x←e]                     f[x←e] g[x←e]

Wir können also eine λ-Abstraktion unter eine Applikation schieben:

          λx                    _@_
          |                    /   \           
          @        -->        @     λx         
         / \                 / \    |
        f   g               S   λx  g
                                |
                                f


Wozu das gut ist?

  * Alleine auf `S` und `K` und deren Anwendung basiert der Kalkül
    “Combinatory Logic” (CL).  Dieser ist in seiner
    Ausdrucksmächtigkeit äquivalent zum λ-Kalkül.

  * `S` und `K` werden auch Schönfinkel-Kombinatoren genannt [1].

  * Die Programmiersprache Unlambda [2] baut ausschließlich auf diesen
    beiden Kombinatoren und deren Anwendung auf.



Frage: Was kommt hier raus?

    S K K q

Antwort:  q

    S K K q =  K q (K q)  =  q

Beweis:
                
    lazy' $ app [sc, kc, kc, Var "q"]

⇒  S K K  ≡  I

> ic :: LExpr
> ic = sc `App` kc `App` kc

Ausprobieren:

    ic
    lazy' $ ic `App` Var "q"


- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
Der SK-Kalkül


Man kann λ-Ausdrücke vollständig durch die Kombinatoren `S` und `K`
beschreiben.  Dafür führen wir den SK-Kalkül ein:


Grammatik des SK-Kalkül
-----------------------

    * SKExpr → S
             | K
             | I               -- als Abkürzung für `S K K`
             | SKExpr SKExpr   -- Applikation
             | Const

      Const → …          -- Freie Variablen oder Konstanten stellen
                            wir als String dar, z.B. "1", "plus", …

> data SK
>     = S
>     | K
>     | I
>     | SK :@ SK     -- Anwendung eines SK-Ausdrucks auf einen anderen
>     | V String     -- Konstanten oder freie Variablen

> infixl 4 :@

Der Haskell-Konstruktor `:@` erzeugt eine SK-Applikation, analog zu
`App`, das eine LExpr-Applikation erzeugt.


SK-Ausdrücke können ausgegeben werden:

> instance Show SK where
>     showsPrec _ S = showString "S"
>     showsPrec _ K = showString "K"
>     showsPrec _ I = showString "I"
>     showsPrec p (e1 :@ e2)
>         = showParen (p > 0)
>           $
>           shows e1 . showChar ' ' . showsPrec 1 e2
>     showsPrec _ (V v) = showString v

Ausprobieren:

    S
    K
    I :@ S
    ((K :@ I) :@ S) :@ S       -- :@ ist linksassoziativ
    K :@ (I :@ S) :@ S


Operationale Semantik des SK-Kalkül
-----------------------------------

Wir kennen die Rechenregeln: Seien `f`, `g`, `x` und `y` SK-Ausdrücke.

    I x     → x
    K x y   → x
    S f g x → (f x) (g x)


Analog zum λ-Auswerter konstruieren wir einen SK-Auswerter:

> skTrace :: SK -> [SK]
> skTrace e = go e []
>     where

      Solange der aktuelle Knoten eine Applikation ist, steige nach
      links ab.

>     go (e1 :@ e2) es         = go e1 (e2:es)

      I x …  →  x …

>     go I          (x:es)     = apply x es

      K x y …  →  x …

>     go K          (x:y:es)   = apply x es

      S f g x …  →  f x (g x) …

>     go S          (f:g:x:es) = let e' = f :@ x :@ (g :@ x)
>                                in apply e' es

      alles Andere können wir nicht reduzieren, es gibt also keine
      weiteren Rechenschritte.

>     go _          _          = []

      `apply e [e1, e2, …]` gibt das Zwischenergebnis `e e1 e2…` aus
      (als Kopf der Liste), und berechnet weitere Zwischenergebnisse
      indem es in `e` absteigt.

>     apply e es = foldl (:@) e es : go e es


Wie oben: Nur das letzte Ergebnis ausgeben, bzw. alle Rechenschritte
schön auf das Terminal schreiben.

> sk :: SK -> SK
> sk = last . skTrace
      
> sk' :: SK -> IO ()
> sk' e = printSteps $ e : skTrace e


Ausprobieren:

    sk' $   I :@ V "foo"
    sk' $   K :@ V "foo" :@ V "bar"
    sk' $   S :@ V "foo" :@ V "bar" :@ V "qux"

    sk' $   S :@ K :@ K :@ V "foo"



Abstraction elimination
-----------------------

Also los: Entfernen wir λ-Abstraktionen und alle *gebundenen*
Variablen aus einem λ-Ausdruck:

> unlambda :: LExpr -> SK


  * Ungebundene Variablen fassen wir als Konstanten auf:

> unlambda (Var v) = V v


Für eine Applikation arbeiten wir einfach in beiden Teilen des
Ausdrucks weiter:

> unlambda (App e1 e2) = unlambda e1 :@ unlambda e2


Bei einer λ-Abstraktion kümmern wir uns zuerst um den Rumpf, und
analysieren wie der aussieht:

> unlambda (Lam x e) = abst x $ unlambda e
>   where

    Dabei berechenet `abst x` die Abstraktion der Variablen `x` von
    einem Funktionsrumpf.

    * Ist der Funktionsrumpf einfach nur die Variable die gebunden
      wird, dann ist die Funktion die Identität:

      λx. x  ↦  I

>     abst x (V y) | x==y  =  I


    * Ist der Rumpf eine Applikation `f g`, dann abstrahieren wir
      `x` von beiden, und setzen Sie mit `S` zusammen, siehe
      Gleichung (*) oben.

      λx. f g  ↦  S (λx. f) (λx. g)

>     abst x (f :@ g)  =  S :@ (abst x f) :@ (abst x g)


    * Sonst ist der Funktionsrumpf entweder `V y` mit `x/=y`, oder ein
      Kombinator.  Alles andere haben wir schon entfernt.

      Insbesondere kommt `x` nicht frei im Funktionsrumpf vor!

      λx. b  ↦  K b

>     abst x b  =  K :@ b



Ausprobieren:

    Lam "x" $ Var "x"
    unlambda it

    Lam "x" $ Var "y"
    unlambda it

    Lam "x" $ Var "foo" `App` Var "bar"
    unlambda it

    cnst
    unlambda it


    app [cnst, Var "foo", Var "bar"]
    unlambda it
    sk' it

    first `App` (pair `App` Var "Bonnie" `App` Var "Clyde")
    unlambda it
    sk' it

    hd `App` gen
    unlambda it
    sk it


Etwas komplexer:

    hd `App` (tl `App` gen)
    unlambda it
    sk it

            Hmmm, was würden wir erwarten?

            `succ 3` eigentlich.

            Schauen wir mal ob das Ergebnis eine Applikation im
            SK-Kalkül ist:

    let (f :@ x) = it
    f
    x

            Das ging offenbar.  `f` ist `succ`, prima.  Was ist `x`?

    sk x


Unser `skTrace`-Auswerter verwendet überhaupt kein Sharing.  Eine
ernstzunehmende Auswerte-Maschine muss Sharing implementieren, und
aufpassen dass “shared nodes” nicht dupliziert werden!

Demo aus Compilerbau (Winter 2010) zeigen...

    Sharing geht verloren:
    zathura extras/sk-trace/4-unshare1.pdf
    
    Sharing bleibt erhalten (veräderte Auswertestrategie):
    zathura extras/sk-trace/4-unshare3.pdf

Wen das interessiert, Turner [3] behandelt das ziemlich ausführlich.
Auch führt er weitere Kombinatoren ein um den Code kompakter, und die
Auswertemaschine effizienter zu machen.



Hinweis: Der SK-Kalkül und die Schönfinkel-Kombinatoren sind *nicht*
         prüfungsrelevant!


----------------------------------------------------------------------


[1] Wikipedia: Moses Schönfinkel
    http://en.wikipedia.org/wiki/Moses_Sch%C3%B6nfinkel

[2] The Unlambda Programming Language
    http://www.madore.org/~david/programs/unlambda/

[3] David A. Turner.  “A New Implementation Technique for Applicative
    Languages”.  In: Software—Practice and Experience 9 (1979),
    pp. 31–49.

                
======================================================================
